leetcode 453. 最小操作次数使数组元素相等 中等

给你一个长度为 n 的整数数组,每次操作将会使 n - 1 个元素增加 1 。返回让数组所有元素相等的最小操作次数。

示例 1:

复制代码
输入:nums = [1,2,3]
输出:3
解释:
只需要3次操作(注意每次操作会增加两个元素的值):
[1,2,3]  =>  [2,3,3]  =>  [3,4,3]  =>  [4,4,4]

示例 2:

复制代码
输入:nums = [1,1,1]
输出:0

提示:

  • n == nums.length
  • 1 <= nums.length <= 10^5
  • -10^9 <= nums[i] <= 10^9
  • 答案保证符合 32-bit 整数

分析:因为只需要找出让数组所有元素相等的最小操作次数,所以不需要真正算出数组中所有元素相等时的元素值,只需要考虑数组中元素相对大小的变化即可。每次操作既可以理解为使 n−1 个元素增加 1,也可以理解使 1 个元素减少 1。总操作次数等于将数组中所有元素均变成最小元素的操作次数。

cpp 复制代码
class Solution {
public:
    int minMoves(vector<int>& nums) {
        int n=nums.size(),mini=INT_MAX,ans=0;
        for(int i=0;i<n;++i)
            mini=min(mini,nums[i]);
        for(int i=0;i<n;++i)
            ans+=nums[i]-mini;
        return ans;
    }
};
相关推荐
Tisfy5 小时前
LeetCode 0453.最小操作次数使数组元素相等:两次遍历(反向思维)
算法·leetcode·题解·遍历·反向思维
君万5 小时前
【LeetCode每日一题】回溯:46. 全排列 78. 子集 39. 组合总和
算法·leetcode·go
Tisfy7 小时前
LeetCode 3665.统计镜子反射路径数目:三个动态规划数组
leetcode·动态规划·代理模式·题解
海绵宝宝转agent8 小时前
LeetCode100 二叉树个人题解
算法·leetcode·深度优先
文丑颜不良啊9 小时前
LeetCode1581~1600题目解析
java·leetcode
文丑颜不良啊12 小时前
LeetCode1541~1560题目解析
java·leetcode
文丑颜不良啊1 天前
LeetCode1481~1500题目解析
java·leetcode
文丑颜不良啊1 天前
LeetCode1381~1400题目解析
java·leetcode
Tisfy1 天前
LeetCode 3882.网格图中最小异或路径:动态规划
算法·leetcode·动态规划